Subject: CPE router draft: Default route and WAN interface provisioning

From: Ole Troan <[email-masked]>
Date: Wed, 2 Dec 2009 18:19:02 +0100

as the editor of the draft-ietf-v6ops-ipv6-cpe-router let me bring the following questions to the list.

the IPv6 CE router WAN interface needs to acquire addresses i.e behave like a host if one follows the definition in RFC4862. it forwards traffic out this interface so it is also a router.
we don't want to redefine the host/router definitions in 4861/4862. for the purposes of address assignment of a router interface, is this text acceptable and clear:

   "When the router is attached to the WAN interface link it must act as
   an IPv6 host for the purposes of stateless or stateful interface
   address assignment ([RFC4862]/[RFC3315]).  The router acts as a
   requesting router for the purposes of DHCP prefix delegation
   ([RFC3633])."

the IPv6 CE router also needs to set up routing. rfc3633 does not say anything about routing. there are multiple ways the IPv6 CE router's routing table could be set up. we're suggesting to include this requirement as a last resort catch to get a default route installed:

   "WPD-3:  Absent of other routing information the IPv6 CE router MUST
           use Router Discovery as specified in [RFC4861] to discover a
           default router and install a default route in its routing
           table with the discovered router's adddress as the next-hop."

these are the last remaining issues we have with the CPE router draft before we'd like to publish a revision which I hope should be ready for WG last call. 

cheers,
Ole

---

From: Ted Lemon <[email-masked]>
Date: Wed, 2 Dec 2009 11:13:18 -0700

> these are the last remaining issues we have with the CPE router draft before we'd like to publish a revision which I hope should be ready for WG last call. 

The text you've proposed sounds fine to me.

---

From: Gregory Lebovitz <[email-masked]>
Date: Wed, 2 Dec 2009 10:47:04 -0800

On Wed, Dec 2, 2009 at 9:19 AM, Ole Troan <[email-masked]> wrote:

> the IPv6 CE router WAN interface needs to acquire addresses i.e behave like
> a host if one follows the definition in RFC4862. it forwards traffic out
> this interface so it is also a router.
> we don't want to redefine the host/router definitions in 4861/4862. for the
> purposes of address assignment of a router interface, is this text
> acceptable and clear:
>

GML> Very minor rework, having JUST brought up a new DSL line last night on
my new Juniper SSG-5, and Westell DSL modem:

GML>  "When the router's WAN interface link becomes active, and the
provider/customer have agreed upon dynamic interface configuration (as
opposed to static configuration of IP parameters) it must momentarily act
as an IPv6 host for the purposes of stateless or stateful interface address
assignment ([RFC4862]/[RFC3315]). The router acts as a requesting router for
the purposes of DHCP prefix delegation ([RFC3633])."

>
> the IPv6 CE router also needs to set up routing. rfc3633 does not say
> anything about routing. there are multiple ways the IPv6 CE router's routing
> table could be set up. we're suggesting to include this requirement as a
> last resort catch to get a default route installed:
>

wfm.

>
> these are the last remaining issues we have with the CPE router draft
> before we'd like to publish a revision which I hope should be ready for WG
> last call.
>
> cheers,
> Ole
>
>
>

-- 
----
IETF related email from
Gregory M. Lebovitz
Juniper Networks

---

From: "Templin, Fred L" <[email-masked]>
Date: Wed, 2 Dec 2009 11:47:20 -0800

Ole,

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of Ole Troan
> Sent: Wednesday, December 02, 2009 9:19 AM
> To: [email-masked]
> Subject: CPE router draft: Default route and WAN interface provisioning
> 
> the IPv6 CE router WAN interface needs to acquire addresses i.e behave like a host if one follows the
> definition in RFC4862. it forwards traffic out this interface so it is also a router.
> we don't want to redefine the host/router definitions in 4861/4862. for the purposes of address
> assignment of a router interface, is this text acceptable and clear:
> 

Why does it need a non-link-local address on the WAN
interface? If it is going to act as a requesting router
in DHCP prefix delegation, it can get non-link-local
addresses to assign to its other interfaces.
 
> the IPv6 CE router also needs to set up routing. rfc3633 does not say anything about routing. there
> are multiple ways the IPv6 CE router's routing table could be set up. we're suggesting to include
> this requirement as a last resort catch to get a default route installed:
> 
> these are the last remaining issues we have with the CPE router draft before we'd like to publish a
> revision which I hope should be ready for WG last call.

If the IPv6 CE uses Router Discovery as specified in
[RFC4861], then it will send RS and any default routers
that hear it will set IsRouter to FALSE in the
corresponding neighbor cache entry.

Fred
[email-masked]

---

From: Ole Troan <[email-masked]>
Date: Wed, 2 Dec 2009 23:54:56 +0100

Gregory,

[...]

> GML> Very minor rework, having JUST brought up a new DSL line last night on my new Juniper SSG-5, and Westell DSL modem:
> 
> GML>  "When the router's WAN interface link becomes active, and the provider/customer have agreed upon dynamic interface configuration (as opposed to static configuration of IP parameters) it must momentarily act as an IPv6 host for the purposes of stateless or stateful interface address assignment ([RFC4862]/[RFC3315]). The router acts as a requesting router for the purposes of DHCP prefix delegation ([RFC3633])."

with regards to "momentarily" both SLAAC and DHCP address assignment are not something you can only do when you bring up an interface. you need to in the case of DHCP renew leases and in the case of SLAAC process RAs at least as often as the prefix lifetime. so, even though it would be nice if we could say "momentarily" I do think the interface has to behave with this host/router duality continuously.

cheers,
Ole

---

From: Ole Troan <[email-masked]>
Date: Wed, 2 Dec 2009 23:52:16 +0100

Fred,

> addresses to assign to its other interfaces.

you can of course redefine the problem and say that they link should have no global addresses.
it is an operational choice if one wants to number it or not, and in any case one would want to cater for the case where both hosts and routers are connected to the SP router which then doesn't have to behave differently for which device connects to it.

> corresponding neighbor cache entry.

that is correct. do you see any problems with that?

cheers,
Ole

---

From: "Templin, Fred L" <[email-masked]>
Date: Wed, 2 Dec 2009 15:36:58 -0800

> that is correct. do you see any problems with that?

I'm not sure, and maybe the behavior is implementation
dependent. For example, if a router in the operator network
has a FIB entry with nexthop corresponding to a CPE router,
but the IsRouter flag in the neighbor cache entry for the
nexthop is FALSE, will some implementations refuse to
forward packets via the nexthop while others permit it?

Thanks - Fred

---

From: Mikael Abrahamsson <[email-masked]>
Date: Thu, 3 Dec 2009 08:39:08 +0100 (CET)

>   requesting router for the purposes of DHCP prefix delegation

How does this work together with:

"WAA-6:  If the IPv6 CE router does not acquire a global IPv6 address
            from either SLAAC or DHCP, then it MUST create a global IPv6
            address from its delegated prefix and configure that on one
            of its internal virtual network interfaces."

Does it only mean that it must potentially act as a host and try to get an 
IPv6 address, but it's ok if it doesn't ? Is it possible that people will 
be confused by this and it needs more clarification? Should it also say 
that this virtual network interface must be used to source traffic from 
the CPE router to the WAN side?

Then the wording here:

"WPD-3:  If the delegated prefix is an aggregate route of multiple,
            more-specific routes the IPv6 CE router MUST discard packets
            that match the aggregate route, but not any of the more-
            specific routes.  In other words, the "next-hop" for the
            aggregate route should be the null destination.  This is
            necessary to prevent forwarding loops when some addresses
            covered by the aggregate are not reachable.  [RFC4632]"

Would it make sense to specifically say that any PD space received must be 
null routed unless it's used on an interface or routed somewhere else 
(sub-PDed to another router in the home)? Just in case multiple PDs are 
received and a LAN interface goes down?

"L-5:  The IPv6 CE router must assign a separate /64 from its
          delegated prefix (and ULA prefix if configured to provide ULA
          addressing) for each of its LAN interfaces.  The IPV6 CE router
          MUST make the interface an advertising interface according to
          RFC4861.  In router advertisements messages, the Prefix
          Information Option's A/L-bits MUST be set to 1 by default; the
          A/L bits setting SHOULD be user configurable."

Does "LAN interface" refer to physical or vlan interface? What if the home 
CPE has 8 LAN ports and the user would like port 1-3 to be in the same 
vlan and thus share the same /64. Does this wording prohibit this 
behaviour? There is a "must" (shouldn't that be capital letters?) in 
there... I think the behaviour of having multiple ports in the same /64 
and do L2 switching between them should be allowed.

Otherwise I think the document is a fine piece of work! :)

-- 
Mikael Abrahamsson    email: [email-masked]

---

From: Ole Troan <[email-masked]>
Date: Thu, 3 Dec 2009 11:47:25 +0100

Mikael,

thanks for the comments, see inline.

> Does it only mean that it must potentially act as a host and try to get an IPv6 address, but it's ok if it doesn't ? Is it possible that people will be confused by this and it needs more clarification? Should it also say that this virtual network interface must be used to source traffic from the CPE router to the WAN side?

what we are trying to say is that the IPv6 CE router MUST try to acquire an address on its WAN interface using SLAAC and/or DHCP. if that fails then it MUST create an address from the delegated prefix. this should allow for all addressing models, including the one where the WAN link is not numbered with globally scoped addresses.
please feel free to suggest better text.

with regards to source address selection. it might be prudent to state that the IPv6 CE router supports the weak host model and can use a source address from a different interface than the interface the packet is sent out of.

> Would it make sense to specifically say that any PD space received must be null routed unless it's used on an interface or routed somewhere else (sub-PDed to another router in the home)? Just in case multiple PDs are received and a LAN interface goes down?

that's what we are trying to say. i.e that you have a null route for the aggregate, aka the delegated prefix. parts of this text is from rfc4632. any improved proposed text would be appreciated.

> Does "LAN interface" refer to physical or vlan interface? What if the home CPE has 8 LAN ports and the user would like port 1-3 to be in the same vlan and thus share the same /64. Does this wording prohibit this behaviour? There is a "must" (shouldn't that be capital letters?) in there... I think the behaviour of having multiple ports in the same /64 and do L2 switching between them should be allowed.

we have received multiple comments on this. suggestions are welcome!
since this is a router I thought it obvious that whenever we talked about an interface it would be clear that it was a   L3 routed interface connected to an IPv6 link. this document does not concern itself with bridging or switches on L2. e.g a typical IPv6 CE router would have 4 downstream Ethernet ports, but these are typically switched and represented as a single IPv6 LAN interface.

> Otherwise I think the document is a fine piece of work! :)

thanks!

Best regards,
Ole

---

From: Mikael Abrahamsson <[email-masked]>
Date: Thu, 3 Dec 2009 12:23:35 +0100 (CET)

On Thu, 3 Dec 2009, Ole Troan wrote:

> with regards to source address selection. it might be prudent to state 
> that the IPv6 CE router supports the weak host model and can use a 
> source address from a different interface than the interface the packet 
> is sent out of.

I agree, I think it would be nice to mention that in the document, I think 
it deserves a clarification.

> that's what we are trying to say. i.e that you have a null route for the 
> aggregate, aka the delegated prefix. parts of this text is from rfc4632. 
> any improved proposed text would be appreciated.

Darn, I've just spent 10 minutes trying to come up with better wording but 
I can't really come up with something better that is still simple and 
short. Let's leave it as it is, at least I can't come up with something 
better.

>> Does "LAN interface" refer to physical or vlan interface? What if the 
>> home CPE has 8 LAN ports and the user would like port 1-3 to be in the 
>> same vlan and thus share the same /64. Does this wording prohibit this 
> since this is a router I thought it obvious that whenever we talked 
> about an interface it would be clear that it was a L3 routed interface 
> connected to an IPv6 link. this document does not concern itself with 
> bridging or switches on L2. e.g a typical IPv6 CE router would have 4 
> downstream Ethernet ports, but these are typically switched and 
> represented as a single IPv6 LAN interface.

What about adding text to L-5:

"... its LAN interfaces (single logical interface, might be one or 
multiple physical ports with L2 switching between them). ..."

But if we go into this area, should we make recommendations regarding MLD 
snooping in switched L2-domains as well?

---

From: Antonio Querubin <[email-masked]>
Date: Tue, 8 Dec 2009 07:17:22 -1000 (HST)

On Thu, 3 Dec 2009, Mikael Abrahamsson wrote:

> "... its LAN interfaces (single logical interface, might be one or multiple 
> physical ports with L2 switching between them). ..."
>

How about just saying "routed LAN interface" or "logical LAN interface"? 
Would that be reasonably clear without adding much wording?

Antonio Querubin
808-545-5282 x3003
e-mail/xmpp:  [email-masked]

---

From: "Hemant Singh (shemant)" <[email-masked]>
Date: Tue, 8 Dec 2009 11:45:29 -0600

Antonio,

A better term would be "LAN network interface" so that the network
interface term can be understood to be a logical or a physical
interface.  Does this work for you?

Thanks,

Hemant

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of Antonio Querubin
Sent: Tuesday, December 08, 2009 12:17 PM
To: Mikael Abrahamsson
Cc: [email-masked]
Subject: Re: CPE router draft: Default route and WAN interface
provisioning

> "... its LAN interfaces (single logical interface, might be one or
multiple 

Antonio Querubin
808-545-5282 x3003

---

From: Antonio Querubin <[email-masked]>
Date: Tue, 8 Dec 2009 08:26:30 -1000 (HST)

> interface.  Does this work for you?

I think the difficulty is in "separate /64" combined with "LAN interface". 
We want separate /64s on routed (logical) interfaces but not every 
switched (vlan) interface.  I think that's what Mikael was pointing out.

Antonio Querubin
808-545-5282 x3003